package com.yuandian.dataflow.master;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketException;
import java.nio.Buffer;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.ArrayList;

import com.yuandian.dataflow.proto.decode.PacketBase;
import com.yuandian.dataflow.proto.decode.PacketHeader;

import lombok.Cleanup;
import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

/**
 * Header
 */
@Slf4j

public class Header {

    public static void main(String[] args) throws Exception {

        var addr = new InetSocketAddress("192.168.1.248", 60001);
        @Cleanup
        var sock = new Socket();
        sock.setReceiveBufferSize(10 * 1024 * 1024);// socket接收缓存
        sock.setSoTimeout(1000 * 30);
        // 设置超时
        sock.connect(addr, 10 * 1000);
        var in = new DataInputStream(sock.getInputStream());
        var out = new DataOutputStream(sock.getOutputStream());
        // 发送验证字符串
        out.write("public".getBytes());
        log.error("{}", PacketHeader.PacketCode(in));
        var pheader = new PacketHeader(in);
        
        log.error("{}", pheader);
        log.error("{}",PacketBase.createPacketBase(pheader));


        //60010流需要解压
        byte[] unzipbodydata = null;
        if (pheader.getTableID() == 20) {
    
            pheader.parseNextHeader_60010(in);

            byte[] zipbodydata = new byte[packetHeader.getMsg_len()];
            readTillLength(zipbodydata, packetHeader.getMsg_len());
            unzipbodydata = ZlibUtil.Inflate(zipbodydata);

        }

    }
}
