package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;
import java.util.Date;

 


public class BussFlowExternal extends PacketBase {
	private final int UNIT_DATA_LENGTH =871; 

	@Override
	public int getUnitPacketLength() {
		return UNIT_DATA_LENGTH;
	}

	public BussFlowExternal  Parse(PacketHeader header,ByteBuffer data)
			throws Exception {

				
		if (data.position() + UNIT_DATA_LENGTH > data.array().length)
			throw new Exception("data length error!");

			
		BussFlowExternal buss = new BussFlowExternal();		
//		buss.m_Header = header;
		
		buss.probe_if= data.getLong(4);

		buss.channel= data.alignedSlice(24).toString();
		 
		buss.interfaceid= data.alignedSlice(100).toString();
		 
		buss.systemName= data.alignedSlice(32).toString();
		 
		buss.net_type= data.alignedSlice(6).toString();

		buss.net_segment =  data.alignedSlice( 5).toString();

		buss.session_id= data.alignedSlice(80).toString();
		 
		buss.phoneid= data.alignedSlice(12).toString();
		 
	
		buss.request_ip= data.getLong(4);

		buss.request_port= data.getLong(4);

		buss.response_ip= data.getLong(4);

		buss.response_port= data.getLong(4);

		//开始时间
		buss.start_tv_sec= data.getLong(4);

		buss.start_tv_usec= data.getLong(4);

		//结束时间
		buss.end_tv_sec= data.getLong(4);

		buss.end_tv_usec= data.getLong(4);

		
		buss.deal_state= data.getInt(4);

		buss.server_translate_time= data.getLong(8);

		buss.server_response_time= data.getLong(8);

		buss.begin_url= data.alignedSlice(100).toString();
		 
		buss.operating_sytem= data.alignedSlice(20).toString();
		 
		buss.server_res_code= data.getInt(2);

		buss.browser= data.alignedSlice(30).toString();
		 
		buss.business_detail_mesg= data.alignedSlice(200).toString();
		 
		buss.business_involve_msg =  data.alignedSlice(200).toString();
		 
		isUncomplete =  data.getInt( 4);

		buss.time_flag= data.getLong( 4);

		return buss;
	}
	
	public String id;
	public Long  probe_if;//接口号
	public String channel;//营业厅渠道：前台或者分析服务器给出,渠道标识
	public String systemName;  //外部系统名称
	public String interfaceid;// 业务接口编码
	public String session_id;//sessionid
	public String phoneid;//受理手机号码
	public String net_type;
	public String  net_segment;//网段标识(客户-web)
	public Long request_ip;//Web客户端IP
	public Long request_port;//Web客户端端口
	public Long  response_ip;//Web服务器IP
	public Long response_port;//Web服务器端口
	
	public  Long start_tv_sec;//Web开始时间秒
	public Long start_tv_usec;//开始时间微秒
	public Long end_tv_sec;//结束时间秒
	public  Long end_tv_usec;//结束时间微妙
	
	public Integer deal_state;//Web操作成功/失败标识1成功0失败
	public Long server_translate_time;//Web服务器传输耗时
	public Long server_response_time;//Web服务器响应时间
	public String begin_url;//url
	public String operating_sytem;//操作系统
	public Integer server_res_code; //Web系统返回码
	public String browser;//浏览器
	public String business_detail_mesg;//要获取的指标
	public Date insert_time;//插入时间
	public String business_involve_msg; //要关联的指标
	public Integer isUncomplete;
	public Long time_flag;


	@Override
	public String[] getData() {
		String data[] = new String[37];
		return data;
	}

	@Override
	public int getInterfaceNumber() {
		
		return Integer.parseInt(probe_if.toString());
	}

	

	
}
