package com.yuandian.dataflow.proto.decode;
import java.nio.ByteBuffer;

import lombok.ToString;

@ToString
public abstract class PacketBase {

	protected PacketHeader m_Header = null;
	
	public PacketHeader getPacketHead(){
		return m_Header;
	}
	
	public void setPacketHeader(PacketHeader header)
	{
		this.m_Header = header;
	}
	
	//抽象方法，每个数据操作类实现不一样
	public abstract PacketBase  Parse(PacketHeader header,ByteBuffer data) throws Exception;
	
	public abstract int getUnitPacketLength();
	
	public abstract String[] getData();
	
	public abstract int getInterfaceNumber();
	
	 
	public static PacketBase createPacketBase(PacketHeader packetHeader) {
        // 获取报文头
 
        // 响应表ID
        int table_id = packetHeader.getTableID();
        switch (table_id) {
            case 17:
                AppFlow appFlow = new AppFlow();
                appFlow.setPacketHeader(packetHeader);
                return appFlow;
            case 18:
                QoeFlow qoeFlow = new QoeFlow();
                qoeFlow.setPacketHeader(packetHeader);
                return qoeFlow;
            case 20:
                SstFlow sstFlow = new SstFlow();
                sstFlow.setPacketHeader(packetHeader);
                return sstFlow;
            case 22:
                BussFlowWeb tBusiness = new BussFlowWeb();
                tBusiness.setPacketHeader(packetHeader);
                return tBusiness;
            case 23:
                BussFlowMidd secondBusiness = new BussFlowMidd();
                secondBusiness.setPacketHeader(packetHeader);
                return secondBusiness;
            case 24:
                BussFlowDb thirdBusiness = new BussFlowDb();
                thirdBusiness.setPacketHeader(packetHeader);
                return thirdBusiness;
            case 25:
                BussFlowOrl tExternalBusiness = new BussFlowOrl();
                tExternalBusiness.setPacketHeader(packetHeader);
                return tExternalBusiness;
            case 27:
                DataFlow dataFlow = new DataFlow();
                dataFlow.setPacketHeader(packetHeader);
                return dataFlow;
            case 28:
                ApmBaseDataFlow apmBaseDataFlow = new ApmBaseDataFlow();
                apmBaseDataFlow.setPacketHeader(packetHeader);
                return apmBaseDataFlow;
            case 29:
                BasicTrafficFlow BasicTrafficFlow = new BasicTrafficFlow();
                BasicTrafficFlow.setPacketHeader(packetHeader);
                return BasicTrafficFlow;
            default:
                return null;
        }
    }
}
