/**
 * description
 *
 * @author eson
 *2022年6月07日-11:09:21
 */
package com.yuandian.dataflow.proto.decode;

import java.io.DataInputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

/**
 * description
 *
 * @author eson
 *2022年6月07日-11:09:21
 */
@Getter
@Setter
@ToString
public class PacketHeader {
 
        private int tableID = -1; //数据类型
        private int recCount = 0;	//数据总条数
        private int msgLen;	//数据报文总长度，60010端口为压缩后长度
        private long timestamp;	//60010端口发送数据时间
        private int probeIf;	//60010端口抓包口
        private int umcomprLen;//60010端口数据报文压缩前长度
        private int nowType; //记录25类型数据数据当前数据类型 22 23 24

        public PacketHeader(DataInputStream data) throws Exception {
            this.tableID = ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN).getInt();//22
            this.recCount = ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN).getInt();//4000
            this.msgLen = ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN).getInt();
        }
        
        public void parseNextHeader_60010(DataInputStream data) throws Exception {
            this.timestamp = ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN).getLong();
            this.probeIf =ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN).getInt();
            this.umcomprLen = ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN).getInt();
        }

        public static int PacketCode(DataInputStream data) throws IOException  {
            var buf = ByteBuffer.wrap( data.readNBytes(4)).order(ByteOrder.LITTLE_ENDIAN);
            return buf.getInt();
        }
     

}
