/**
 * 
 */
package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;

import io.netty.buffer.ByteBuf;

/**
 * @author l
 * 网络性能流
 */
public class QoeFlow extends PacketBase {
	private String qoe_Flow_Id; 
	public static int SIZE = 38*4;
//		字段类型		字段							原始类型	    字节数 	说明 
public int srcIp;	 					 //uint32_t 	4	源ip地址
public int dstIp;	 					 //uint32_t 	4	目的ip地址
public int stvSec; 	 				 //uint32_t 	4	开始时间秒
public int stvUsec; 	 				 //uint32_t 	4	开始时间微秒
public int ltvSec;	 				 //uint32_t 	4	最后更新时间秒
public int ltvUsec;	 				 //uint32_t 	4	最后更新时间微秒
public int dst2ResponNum;	 		 	 //uint32_t 	4	响应总量
public int dst2Fast;	 				 //uint32_t 	4	
public int dst2FastExpected;	 		 //uint32_t 	4	
public int dst2ExpectedDegrated;	 	 //uint32_t 	4	
public int dst2DegratedService;	 	 //uint32_t 	4	
public int dst2ServiceAvailability;	 //uint32_t 	4	
public int dst2ResponTimeout;	 	 	 //uint32_t 	4	响应超时数
public int dst2ResponSuccess;	 	 	 //uint32_t 	4	响应成功数
public int dst2ResponFail;	 		 //uint32_t 	4	响应失败数
public int dst2ResponPeek;	 		 //uint32_t 	4	峰值响应时间
public int dst2ResponAverage;	 	 	 //uint32_t 	4	响应时间均值
public int csWindow;	 				 //uint32_t 	4	
public int scWindow;	 				 //uint32_t 	4	
public int csReset;	 				 //uint32_t 	4	
public int scReset;	 				 //uint32_t 	4	
public int csRetran;	 				 //uint32_t 	4	
public int scRetran;	 				 //uint32_t 	4	
public int appId;	 					 //uint32_t 	4	Aphid
public int appGroupId;	 			 //uint32_t 	4	app组id
public int probeIf;					 //uint32_t 	4	探针接口id
public int appStyle;					 //uint32_t 	4	
public int timeFlag;					 //uint32_t 	4	发送时间戳
public int connSetupTm;				 //uint32_t 	4	链接建立时间
public int dataTransferTm;			 //uint32_t 	4	数据传输时间
public int retransDelayTm;			 //uint32_t 	4	数据重传时延
public int networkInbound;			 	 //uint32_t 	4	网络响应时间（c->s）
public int networkOutbound;			 //uint32_t 	4	网络响应时间（s->c）
public int newSession;				 	 //uint32_t 	4	新会话数
public int userEvents;				 	 //uint32_t 	4	用户事件
public int serverEvents;				 //uint32_t 	4	服务事件
public int connSetupPeek;			 	 //uint32_t 	4	连接建立时间峰值
public int vlanId;					 	 //uint32_t 	4



@Override
public QoeFlow Parse(PacketHeader header,ByteBuffer data) throws Exception {
	QoeFlow qoeFlow = new QoeFlow();
	qoeFlow.srcIp=data.getInt( 4);
	 
	qoeFlow.dstIp=data.getInt( 4);
	 
	qoeFlow.stvSec=data.getInt( 4);
	 
	qoeFlow.stvUsec=data.getInt( 4);
	 
	qoeFlow.ltvSec=data.getInt( 4);
	 
	qoeFlow.ltvUsec=data.getInt( 4);
	 
	qoeFlow.dst2ResponNum=data.getInt( 4);
	 
	qoeFlow.dst2Fast=data.getInt( 4);
	 
	qoeFlow.dst2FastExpected=data.getInt( 4);
	 
	qoeFlow.dst2ExpectedDegrated=data.getInt( 4);
	 
	qoeFlow.dst2DegratedService=data.getInt( 4);
	 
	qoeFlow.dst2ServiceAvailability=data.getInt( 4);
	 
	qoeFlow.dst2ResponTimeout=data.getInt( 4);
	 
	qoeFlow.dst2ResponSuccess=data.getInt( 4);
	 
	qoeFlow.dst2ResponFail=data.getInt( 4);
	 
	qoeFlow.dst2ResponPeek=data.getInt( 4);
	 
	qoeFlow.dst2ResponAverage=data.getInt( 4);
	 
	qoeFlow.csWindow=data.getInt( 4);
	 
	qoeFlow.scWindow=data.getInt( 4);
	 
	qoeFlow.csReset=data.getInt( 4);
	 
	qoeFlow.scReset=data.getInt( 4);
	 
	qoeFlow.csRetran=data.getInt( 4);	
	 
	qoeFlow.scRetran=data.getInt( 4);	
	 
	qoeFlow.appId=data.getInt( 4);
	 
	qoeFlow.appGroupId=data.getInt( 4);
	 
	qoeFlow.probeIf=data.getInt( 4);
	 
	qoeFlow.appStyle=data.getInt( 4);
	 
	qoeFlow.timeFlag=data.getInt( 4);
	 
	qoeFlow.connSetupTm=data.getInt( 4);
	 
	qoeFlow.dataTransferTm=data.getInt( 4);
	 
	qoeFlow.retransDelayTm=data.getInt( 4);
	 
	qoeFlow.networkInbound=data.getInt( 4);
	 
	qoeFlow.networkOutbound=data.getInt( 4);
	 
	qoeFlow.newSession=data.getInt( 4);
	 
	qoeFlow.userEvents=data.getInt( 4);
	 
	qoeFlow.serverEvents=data.getInt( 4);
	 
	qoeFlow.connSetupPeek=data.getInt( 4);
	 
	qoeFlow.vlanId=data.getInt( 4);
	 
	return qoeFlow;
}
@Override
public int getUnitPacketLength() {
	// TODO Auto-generated method stub
	return 0;
}
@Override
public String[] getData() {
	// TODO Auto-generated method stub
	return null;
}
@Override
public int getInterfaceNumber() {
	// TODO Auto-generated method stub
	return 0;
}

}
